Attribute VB_Name = "MCUBE_bourke"
Public Function Polygonise(grid As GRIDCEL, isolevel As Single, triangles() As TRIANGLE) As Integer
Static edgeTable(0 To 255) As Integer
Static triTable(0 To 255, 0 To 15) As Integer
Static MCE_Topolgy_Inicialized As Boolean

Dim i As Integer
Dim ntriang As Integer
Dim cubeindex As Integer
Dim vertlist(0 To 11) As XYZ

' checking the topology filed initialization
If MCE_Topolgy_Inicialized = False Then
    MCE_Topolgy_Inicialized = Input_MCE_Toplogy(edgeTable, triTable)
    If MCE_Topolgy_Inicialized = False Then
        MsgBox "Uanble to load MCE topology file(cell_data.dat)"
        Stop
    End If
End If

' Determine the index into the edge table which
' tells us which vertices are inside of the surface

cubeindex = 0
If (grid.value(0) < isolevel) Then cubeindex = cubeindex Or 1
If (grid.value(1) < isolevel) Then cubeindex = cubeindex Or 2
If (grid.value(2) < isolevel) Then cubeindex = cubeindex Or 4
If (grid.value(3) < isolevel) Then cubeindex = cubeindex Or 8
If (grid.value(4) < isolevel) Then cubeindex = cubeindex Or 16
If (grid.value(5) < isolevel) Then cubeindex = cubeindex Or 32
If (grid.value(6) < isolevel) Then cubeindex = cubeindex Or 64
If (grid.value(7) < isolevel) Then cubeindex = cubeindex Or 128

' cube is intirely in/out of the surface
If (edgeTable(cubeindex)) = 0 Then
    Polygonise = 0
    Exit Function
End If

If (edgeTable(cubeindex) And 1) Then
    vertlist(0) = _
    VertexInterp(isolevel, grid.p(0), grid.p(1), grid.value(0), grid.value(1))
End If

If (edgeTable(cubeindex) And 2) Then
    vertlist(1) = _
    VertexInterp(isolevel, grid.p(1), grid.p(2), grid.value(1), grid.value(2))
End If

If (edgeTable(cubeindex) And 4) Then
    vertlist(2) = _
    VertexInterp(isolevel, grid.p(2), grid.p(3), grid.value(2), grid.value(3))
End If

If (edgeTable(cubeindex) And 8) Then
    vertlist(3) = _
    VertexInterp(isolevel, grid.p(3), grid.p(0), grid.value(3), grid.value(0))
End If

If (edgeTable(cubeindex) And 16) Then
    vertlist(4) = _
    VertexInterp(isolevel, grid.p(4), grid.p(5), grid.value(4), grid.value(5))
End If

If (edgeTable(cubeindex) And 32) Then
    vertlist(5) = _
    VertexInterp(isolevel, grid.p(5), grid.p(6), grid.value(5), grid.value(6))
End If

If (edgeTable(cubeindex) And 64) Then
    vertlist(6) = _
    VertexInterp(isolevel, grid.p(6), grid.p(7), grid.value(6), grid.value(7))
End If

If (edgeTable(cubeindex) And 128) Then
    vertlist(7) = _
    VertexInterp(isolevel, grid.p(7), grid.p(4), grid.value(7), grid.value(4))
End If

If (edgeTable(cubeindex) And 256) Then
    vertlist(8) = _
    VertexInterp(isolevel, grid.p(0), grid.p(4), grid.value(0), grid.value(4))
End If

If (edgeTable(cubeindex) And 512) Then
    vertlist(9) = _
    VertexInterp(isolevel, grid.p(1), grid.p(5), grid.value(1), grid.value(5))
End If

If (edgeTable(cubeindex) And 1024) Then
    vertlist(10) = _
    VertexInterp(isolevel, grid.p(2), grid.p(6), grid.value(2), grid.value(6))
End If

If (edgeTable(cubeindex) And 2048) Then
    vertlist(11) = _
    VertexInterp(isolevel, grid.p(3), grid.p(7), grid.value(3), grid.value(7))
End If

i = 0
ntriang = 0
Do
    If triTable(cubeindex, i) = -1 Then Exit Do
    ntriang = ntriang + 1
    triangles(ntriang).p(0) = vertlist(triTable(cubeindex, i))
    triangles(ntriang).p(1) = vertlist(triTable(cubeindex, i + 1))
    triangles(ntriang).p(2) = vertlist(triTable(cubeindex, i + 2))
    i = i + 3
Loop
    
Polygonise = ntriang
End Function
Private Function VertexInterp(isolevel As Single, p1 As XYZ, p2 As XYZ, valp1 As Single, valp2 As Single) As XYZ
Dim mu As Single
Dim p As XYZ
    
    'varning I am not sure how much correct is folowing sequence
    If (Abs(isolevel - valp1) < 0.00001) Then
        VertexInterp = p1
        Exit Function
    End If
    
    If (Abs(isolevel - valp2) < 0.00001) Then
        VertexInterp = p2
        Exit Function
    End If
    
    If (Abs(valp1 - valp2) < 0.00001) Then
        VertexInterp = p1 ' ???? giving p1 vhen the valueas are close each other
        Exit Function
    End If
    
    mu = (isolevel - valp1) / (valp2 - valp1)
    p.x = p1.x + mu * (p2.x - p1.x)
    p.y = p1.y + mu * (p2.y - p1.y)
    p.z = p1.z + mu * (p2.z - p1.z)
    
    VertexInterp = p
End Function

Private Function Input_MCE_Toplogy(edgeTable() As Integer, triTable() As Integer) As Boolean
' initialization of the MCE topology file (Bourke variant)
Input_MCE_Toplogy = False

Dim i As Integer
Dim j As Integer
Dim A$

Open App.Path & "\" & "cell_data.dat" For Input As #1

Input #1, A$

For i = 0 To 255
    Input #1, edgeTable(i)
Next i

Input #1, A$

For i = 0 To 255
    For j = 0 To 15
        Input #1, triTable(i, j)
    Next j
Next i

Input #1, A$
If A$ = "end" Then Input_MCE_Toplogy = True
End Function

