Attribute VB_Name = "StereoProjection"

Sub stereoproj(xmin As GLfloat, xmax As GLfloat, ymin As GLfloat, ymax As GLfloat, znear As GLfloat, zfar As GLfloat, zzps As GLfloat, dist As GLfloat, eye As GLfloat)

'/* This routine performs the perspective projection for one eye's subfield.
'   The projection is in the direction of the negative z axis.

'   xmin, ymax, ymin, ymax = the coordinate range, in the plane of zero
'   parallax setting, that will be displayed on the screen. The ratio between
'   (xmax-xmin) and (ymax-ymin) should equal the aspect ration of the display.

'   znear, zfar = the z-coordinate values of the clipping planes.

'   zzps = the z-coordinate of the plane of zero parallax setting.

'   dist = the distance from the center of projection to the plane of zero
'   parallax.

'   eye = half the eye separation; positive for the right eye subfield,
'   negative for the left eye subfield. */

Dim xmid As GLfloat, ymid As GLfloat, clip_near As GLfloat, clip_far As GLfloat
Dim top As GLfloat, bottom As GLfloat, left As GLfloat, right As GLfloat
Dim dx As GLfloat, dy As GLfloat, n_over_d As GLfloat

  dx = xmax - xmin
  dy = ymax - ymin

  xmid = (xmax + xmin) / 2#
  ymid = (ymax + ymin) / 2#

  clip_near = dist + zzps - znear
  clip_far = dist + zzps - zfar

  n_over_d = clip_near / dist

  top = n_over_d * dy / 2#
  bottom = -top
  right = n_over_d * (dx / 2# - eye)
  left = n_over_d * (-dx / 2# - eye)
  
  glMatrixMode GL_PROJECTION
   
  glLoadIdentity
  
  glFrustum left, right, bottom, top, clip_near, clip_far

  glTranslatef -xmid - eye, -ymid, -zzps - dist
  
End Sub

Sub stereoproj_picking(xmin As GLfloat, xmax As GLfloat, ymin As GLfloat, ymax As GLfloat, znear As GLfloat, zfar As GLfloat, zzps As GLfloat, dist As GLfloat, eye As GLfloat)

'/* This routine performs the perspective projection for one eye's subfield.
'   The projection is in the direction of the negative z axis.

'   xmin, ymax, ymin, ymax = the coordinate range, in the plane of zero
'   parallax setting, that will be displayed on the screen. The ratio between
'   (xmax-xmin) and (ymax-ymin) should equal the aspect ration of the display.

'   znear, zfar = the z-coordinate values of the clipping planes.

'   zzps = the z-coordinate of the plane of zero parallax setting.

'   dist = the distance from the center of projection to the plane of zero
'   parallax.

'   eye = half the eye separation; positive for the right eye subfield,
'   negative for the left eye subfield. */

Dim xmid As GLfloat, ymid As GLfloat, clip_near As GLfloat, clip_far As GLfloat
Dim top As GLfloat, bottom As GLfloat, left As GLfloat, right As GLfloat
Dim dx As GLfloat, dy As GLfloat, n_over_d As GLfloat

  dx = xmax - xmin
  dy = ymax - ymin

  xmid = (xmax + xmin) / 2#
  ymid = (ymax + ymin) / 2#

  clip_near = dist + zzps - znear
  clip_far = dist + zzps - zfar

  n_over_d = clip_near / dist

  top = n_over_d * dy / 2#
  bottom = -top
  right = n_over_d * (dx / 2# - eye)
  left = n_over_d * (-dx / 2# - eye)

'we can not delete the picking matrix !!!!!!

'  glMatrixMode GL_PROJECTION
'  glLoadIdentity
  
  glFrustum left, right, bottom, top, clip_near, clip_far

  glTranslatef -xmid - eye, -ymid, -zzps - dist
  
End Sub

